function lcm_and_mapper(Params,KNN)


    cls = Params.datasetnm;
    K   = Params.LCM_K;
    Sup = Params.LCM_S;
    U   = Params.LCM_U;   
    dict_size = Params.dictionarySize;
    
    data_out = sprintf('data_%s_KNN_%d_DIC_%d_LCMK_%s_LCMU_%s_LCMS_%s',cls,KNN,dict_size,str_emtry_to_FLH(K),str_emtry_to_FLH(U),str_emtry_to_FLH(Sup));
    
    
    file = sprintf('LCM/%s/LCM_List_%d_%d.txt',cls,KNN,dict_size);
    outFile = sprintf('LCM/%s/%s.txt',cls,data_out);
    if exist(outFile,'file') ~= 2
        build_lcm_data_files(K,Sup,U, file,outFile) ;
    end
    
    sp_make_dir(sprintf('mapper/%d/',KNN));
    fid = fopen(sprintf('mapper/%d/conf.prop',KNN),'w');
    cur_path =pwd();
    fprintf(fid,sprintf('FLH_PATTERN_FILE_PATH=%s/%s\n',cur_path,outFile));    
    fprintf(fid,sprintf('TRANSACTIONS_DIR=%s/%s/transactions/%d/%d\n',Params.data_dir,cls,KNN,dict_size));    
    fprintf(fid,sprintf('HISTOGRAM_DIR=%s/%s/FLH_HISTOGRAMS/%d/%d/%s\n',Params.data_dir,cls,KNN,dict_size,data_out));    
    fprintf(fid,sprintf('NUM_THREADS=%d\n',Params.LCM_NUM_THREADS)); 
    fclose(fid);
    sp_make_dir(sprintf('%s/%s/FLH_HISTOGRAMS/%d/%d/%s\n',Params.data_dir,cls,KNN,dict_size,data_out));   
    mapper(sprintf('mapper/%d',KNN));
    cls = Params.datasetnm; 
    K   = Params.LCM_K;
    Sup = Params.LCM_S;
    U   = Params.LCM_U;   
    dict_size = Params.dictionarySize;    
    data_out = sprintf('data_%s_KNN_%d_DIC_%d_LCMK_%s_LCMU_%s_LCMS_%s',cls,KNN,dict_size,str_emtry_to_FLH(K),str_emtry_to_FLH(U),str_emtry_to_FLH(Sup));   
    histogramDirectory = sprintf('%s/%s/FLH_HISTOGRAMS/%d/%d/%s',Params.data_dir,cls,KNN,dict_size,data_out);    
    binary_f_name = sprintf('FLH_%d_%d_%s_%s_%s.mat',Params.dictionarySize, KNN,str_emtry_to_FLH(Params.LCM_K), str_emtry_to_FLH(Params.LCM_U), str_emtry_to_FLH(Params.LCM_S));
    file  = fullfile(Params.data_dir , Params.datasetnm ,'FLH_Binary_Histograms' , binary_f_name);  
    sp_make_dir(sprintf('%s',file));
    if exist(file) == 2
        load(file); 
        cohist = single(cohist);        
    else
        cohist = single(Load_CSV_FLH_Histograms( Params.filenames, histogramDirectory  ));          
        save(file,'cohist','-v7.3');
    end
    if size(cohist,2) > Params.RELEVANT_PATTERNS
        relevance_t = redundancy_filter(cohist,Params.trnlbl);
        [uu,vv] = sort(relevance_t,'descend');            
        cohist = cohist(:,vv(1:Params.RELEVANT_PATTERNS)); 
    end      
    save(file,'cohist','-v7.3');
    
    
end