function Build_FLH_Histograms( imageFileList, dataBaseDir, dictionarySize,k,patternFile,K,U,S,clsN)
    
    FLHs = dlmread(patternFile,' ');
    FLH_SET = zeros(size(FLHs,1),dictionarySize*k);    
    for i = 1 : size(FLHs,1)       
        [ele,ind] = find(FLHs(i,:)>0);
        flh_ele = FLHs(i,ind);
        FLH_SET(i,:) = hist(flh_ele,[1:dictionarySize*k]);
    end
    
    result = zeros(1,size(FLH_SET,1));  
    
    st = 0;
    fprintf('Start %d %s size %d\n',st,clsN,size(FLH_SET,1) );
    for f = st+1:max( (st+10), size(imageFileList,1))
        tStart = tic;
        imageFName = imageFileList{f};
        [dirN base] = fileparts(imageFName);
        baseFName = [dirN filesep base];      
        
        outHistFile =fullfile(dataBaseDir,sprintf('FLH_HIST_%d_%d',k,dictionarySize), clsN ,sprintf('%s_FLH_HIST_%s_%d_%d_%d.mat', baseFName,clsN,K,U,S));
        if(size(dir(outHistFile),1)~=0 )
            fprintf('Skipping %s / %d progress %d\n', imageFName,st,f);
             continue;
        end
        
        outFCoName = fullfile(dataBaseDir,sprintf('colist_%d_%d',k,dictionarySize) ,sprintf('%s_colist.mat', baseFName));  
        load(outFCoName);
        
        
        result(:,:) =0;      
        for i = 1 : size(colist,2)
            x = (colist{1,i}.words);
            result = findMatches(FLH_SET,x,dictionarySize,k,result) ;
            if mod(i,100) == 1
                fprintf('.'); 
            end
        end
        fprintf('\n');
         sp_make_dir(outHistFile);
        save(outHistFile,'result');
        tElapsed = toc(tStart);
        fprintf('FLH Histograms created : %s Time %f progress %d out of %d \n',imageFName,tElapsed,f,size(imageFileList,1) );        
    end
    
    fprintf('FLH Histogram building compele for the class %s \n',clsN ); 
        
      
end
    
