function Build_Transaction_Files( imageFileList, dataBaseDir, dictionarySize,k,cls)   
    
    nF = 0;
    nE = 0;
        
    for f = 1:size(imageFileList,1)               
        tStart = tic;
        imageFName = imageFileList{f};
        [dirN base] = fileparts(imageFName);
        baseFName = [dirN filesep base];
        outTrFile = sprintf('%s/%s/transactions/%d/%d/%s.txt',dataBaseDir,cls,k,dictionarySize,baseFName);
        sp_make_dir(outTrFile);          
        outFCoName = fullfile(dataBaseDir,cls,sprintf('colist_%d_%d',k,dictionarySize) ,sprintf('%s_colist.mat', baseFName));         
        if exist(outTrFile) == 2
          %   fprintf('Transaction File Exist %s\n',outTrFile); 
             nF = nF + 1;
             continue;
        end
        fid = fopen(outTrFile,'w');        
        if exist(outFCoName) == 2             
            load(outFCoName);
        else          
         %   fprintf('Coloist file cound not found\n');    
            nE = nE + 1;
            fclose(fid);
            continue;
        end           
        LCMFormat_VectMiner_Efficient(colist,fid,dictionarySize,k);
        fclose(fid);
        nF = nF +1;
        tElapsed = toc(tStart);
        %fprintf('Transaction File Created : %s Time %f progress %d out of %d \n',baseFName,tElapsed,f,size(imageFileList,1) );
    end
   
   fprintf('Transaction Files Creation Complete.. Number of Files Created %d. Number of Error Files %d\n',nF,nE);  
    
 
    
    
end