function histogram = Load_CSV_FLH_Histograms( imageFileList, histDir)

   imageFName = imageFileList{1};
   [dirN base] = fileparts(imageFName);
   baseFName = [dirN filesep base];      
   outHistFile =fullfile(histDir,sprintf('%s.txt',base)); 
   r = csvread(outHistFile);
   
   numPatterns =  length(r);
   
   histogram = zeros( size(imageFileList,1),numPatterns,'single');
   err_c = 0;
   for f = 1:size(imageFileList,1)       
        imageFName = imageFileList{f};
        [dirN base] = fileparts(imageFName);
        baseFName = [dirN filesep base];      
        
        outHistFile =fullfile(histDir,sprintf('%s.txt',base));
        if(size(dir(outHistFile),1)~=0 )           
             r = single(csvread(outHistFile));
             if size(r,2) > 1
                %fprintf('FLH Histograms loaded : %s progress %d out of %d size %d max (%d)\n',imageFName,f,size(imageFileList,1),size(r,2),max(r) );   
                histogram(f,:) = r;
             else
                %fprintf('FLH Histograms loaded : %s progress %d out of %d size %d max (%d)\n',imageFName,f,size(imageFileList,1),size(r,2),max(r) );   
                histogram(f,:) = r';
             end
            
        else
            err_c = err_c+1;
        end
        
             
    end
    
    fprintf('FLH Histogram building compele for the class  Errors : %d \n',err_c); 
        
      
end
    
