function sim = similarity(A,B,type)

INTERSECTION = 1;
KL_DIVERGENCE = 2;

if type == INTERSECTION
   sim = sum(min(A,B));
end

if type == KL_DIVERGENCE
    A = A;
    B = B + eps; 
    ind = find( A > 0);
    A = A(ind,:);
    B = B(ind,:);
    sim = sum( ( A .* log(A./B)));
   
end


end