function cohist = BuildCo_Occurance_List( imageFileList, dataBaseDir, dictionarySize,k,dataset,cls,is_build_lcm_file)
    
   fprintf('Building co-list\n');
    outDFName = fullfile(dataBaseDir, cls ,sprintf('dictionary_%d.mat', dictionarySize));
    load(outDFName);
    
    coOUT_DIR = fullfile(dataBaseDir,cls,sprintf('colist_%d_%d',k,dictionarySize));
    
    if exist(coOUT_DIR) ~= 7
        mkdir(coOUT_DIR);
    else 
        if exist(fullfile(coOUT_DIR,'colist.mat')) == 2
            load(fullfile(coOUT_DIR,'colist.mat'));
            return;
        end
    end





    if is_build_lcm_file == 0
        canskip = 1;
        %matlabpool open 
        for f = 1:size(imageFileList,1)        
             tStart = tic;
             createVisualWordCoOccurrenceList(imageFileList , f, dataBaseDir,cls, k, dictionarySize,canskip); 
             tElapsed = toc(tStart);          
             fprintf('Co-colist create for file : %s Time %f progress %d out of %d Class : %s\n',imageFileList{f},tElapsed,f,size(imageFileList,1),cls );
        end
        %matlabpool close
    end
    
    if is_build_lcm_file == 1
        canskip = 0;
        LCM_FILE_NAME = sprintf('LCM/%s/LCM_List_%d_%d.txt',cls,k,dictionarySize);
         if exist(LCM_FILE_NAME) == 2
             fprintf('LCM file exist %s \n',LCM_FILE_NAME);
             return;
         end
        sp_make_dir(LCM_FILE_NAME);
        fid = fopen(sprintf(LCM_FILE_NAME),'w');   
        for f = 1:size(imageFileList,1)       
            tStart = tic; 
            colist = createVisualWordCoOccurrenceList(imageFileList , f, dataBaseDir,cls, k, dictionarySize,canskip);
            LCMFormat_VectMiner_Efficient(colist,fid,dictionarySize,k);
            tElapsed = toc(tStart);          
            %fprintf('LCM File Writtern for file : %s Time %f progress %d out of %d. Class : %s \n',imageFileList{f},tElapsed,f,size(imageFileList,1),cls );
        end   
        fclose(fid);
    end    
    fprintf('Building co-list complete..\n');



end