function  [MKL_Shape, MKL_Shape_TEST] = Create_MKL_Kernel(data,trainset,testset,labels)

traindata = data(trainset>0,:);
testdata = data(testset>0,:);
if size(labels,2) == 1
    labels_index = labels;
else
    [max1,labels_index]=max(labels,[],2);
end
fprintf('Start to build train matrix..\n'); 
nTrain = size(traindata,1);
nTest = size(testdata,1);
MKL_Shape = zeros(nTrain,nTrain);

for x1 = 1 : nTrain    
    for x2 = 1:nTrain        
        MKL_Shape(x1,x2) = sum(min(traindata(x1,:),traindata(x2,:)));       
    end
end 



fprintf('Start to build test matrix..\n');   
MKL_Shape_TEST = zeros(nTest,nTrain);
for m1 = 1 : nTest    
    for n1 = 1:nTrain      
        MKL_Shape_TEST(m1,n1) = sum(min(testdata(m1,:),traindata(n1,:)));        
    end
end