function histogram = Load_FLH_Histograms( imageFileList, dataBaseDir, dictionarySize,k,patternFile,K,U,S,clsN)
    
    FLHs = dlmread(patternFile,' ');    
    histogram = zeros(size(imageFileList,1),size(FLHs,1));      
    fprintf('Start Loading Histograms %s size %d\n',clsN,size(FLHs,1) );    
    for f = 1:size(imageFileList,1)
        tStart = tic;
        imageFName = imageFileList{f};
        [dirN base] = fileparts(imageFName);
        baseFName = [dirN filesep base];      
        
        outHistFile =fullfile(dataBaseDir,sprintf('FLH_HIST_%d_%d',k,dictionarySize), clsN ,sprintf('%s_FLH_HIST_%s_%d_%d_%d.mat', baseFName,clsN,K,U,S));
        if(size(dir(outHistFile),1)~=0 )
            fprintf('Loading %s Progress %d\n', imageFName,f);
            load(outHistFile);
            histogram(f,:) = result;
            tElapsed = toc(tStart);
            fprintf('FLH Histograms loaded : %s Time %f progress %d out of %d \n',imageFName,tElapsed,f,size(imageFileList,1) );   
            continue;
        end
        result(:,:) = 0;
        fprintf('Creating %s / %d\n', imageFName,st);
        outFCoName = fullfile(dataBaseDir,sprintf('colist_%d_%d',k,dictionarySize) ,sprintf('%s_colist.mat', baseFName));  
        load(outFCoName);     
        result(:,:) =0;      
        for i = 1 : size(colist,2)
            x = (colist{1,i}.words);
            result = findMatches(FLH_SET,x,dictionarySize,k,result) ;
            if mod(i,100) == 1
                fprintf('.'); 
            end
        end
        fprintf('\n');
        sp_make_dir(outHistFile);
        save(outHistFile,'result');
        histogram(f,:) = result;
        tElapsed = toc(tStart);
        fprintf('FLH Histograms created : %s Time %f progress %d out of %d \n',imageFName,tElapsed,f,size(imageFileList,1) );        
    end
    
    fprintf('FLH Histogram building compele for the class %s \n',clsN ); 
        
      
end
    
