function histo = normalize_histogram(histo,norm)

W = size(histo,2);
D = size(histo,1);

if(nargin<2)
    norm = 1;
end


 if norm == 1
    for i = 1 : D
           x = histo(i,:);
           x = x ./ sum(x);
           histo(i,:) = x;
    end

 else
       for i = 1 : D
           x = histo(i,:);
           x = x ./ sqrt(sum(x*x'));
           histo(i,:) = x;
       end
  end 
 end
    


