% Normalize the spatial pyramids based on FLH.
% Levels 1 mean 1 * 1 grid or the image
% Level 2 means 2 * 2 grid
function spm = normlizeSpatialPyramids(spm,norm,dictSize,levels)
    total_grids = 0;
    for i = 1 : levels
        total_grids = total_grids + 4^(i-1); 
    end
    
    
        begin = 1;
        for l = 1 : total_grids
            temp = spm(:,begin:begin+dictSize-1);
            spm(:,begin:begin+dictSize-1) = normalize_histogram(temp,norm);
            begin = begin + dictSize;
        end
   

end